#!/usr/bin/perl
#               -------------
#               Plebius! Webtools
#               -------------
#           Set of internet utilities
#
#         File: HTTP.cgi	
#  Description: Uses HTTP protocol to fetch the contents
#               of a remote HTML or text file.
#               http://example.host.com/directory
#       Author: Martin Kretzmann
#        Email: martin@plebius.org
#          Web: http://www.plebius.org
#      Version: 2.0
#  Copyright : 1999-2000 Martin Kretzmann.  All Rights Reserved.
#      License: GNU General Public License. 
#               http://www.plebius.org/cgi-bin/article.pl?aid=000063
#
#====================================================================

require 'output.cgi';

&main;

sub main{
        ($input, $action) = &data_parse;
        &IOSocket;
        $output = join(" ", @output);
        &show($start,$stop,$command,$input,"ERROR: Incompatible data type","HTTP ") if ($output !~ /Content-Type: text/);
        &show($start,$stop,$command,$input,$output,"HTTP ");
}

sub IOSocket{
        use IO::Socket;
        $method = "GET";
        $input =~ s/http:\/\///g;
        my @f = split(/\//, $input);
        $host = $f[0];
        $path = $input;
        $path =~ s/$host//;
        $path ||='/';
        $start = &gettime;
        $socket = new IO::Socket::INET( 
                                   PeerAddr => $host,
                                   PeerPort => 80,
                                   Proto    => 'tcp',
                                   Type     => SOCK_STREAM, ) or die &show($start,$stop,$command,$input,"$@","HTTP ");
        print $socket "$method $path HTTP/1.0\nHost: $host\nReferrer: http://www.plebius.org\nUser-Agent: Plebius! Webtools (http://www.plebius.org/scripts/perl/webtools/)\n\n";
        @output = <$socket>;
        close ($socket);    
        $stop = &gettime;
}
